package ap.proof;

import ap.terfor.{Formula, TermOrder}
import ap.util.Debug

object ProofTree {
  
  private val AC = Debug.AC_PROOF_TREE
  
}

trait ProofTree {

  //////////////////////////////////////////////////////////////////////////////
  Debug.assertCtor(ProofTree.AC, order isSortingOf closingConstraint)
  //////////////////////////////////////////////////////////////////////////////
  
  val closingConstraint : Formula
  
  /**
   * <code>true</code> if it is possible to apply rules to any goal in this
   * tree
   */
  val stepPossible : Boolean
  
  /**
   * <code>true</code> if there are chances that the
   * <code>closingConstraint</code> of this tree changes by applying rules
   * to any goal
   */
  val stepMeaningful : Boolean
  
  protected val order : TermOrder
  
}
