package ap.proof.goal;

/**
 * Trait for tasks that are 
 * given a <code>priority</code>, based on the age (to ensure fairness)
 * and on other criteria to work at different tasks in a meaningful order.
 * Tasks with smaller <code>priority</code> are supposed to be handled first.
 * Proof tasks of this kind cannot fail, i.e., the result of <code>apply</code>
 * is simply <code>ProofTree</code>.
 */
trait PrioritisedTask extends Task {

  val priority : Int
  
}
